// Ex-p5-Limnimetre-Random7
// 5-1-2017
// Pour p5.js
// Utilise: libraries/p5.js
// https://p5js.org/reference/#/p5/rect
// https://p5js.org/examples/arrays-array.html
// http://atomicrobotdesign.com/blog/javascript/stuff-they-dont-tell-javascript-noobs-making-copies-of-arrays/

var LargeurRectangle = 120; // 300 120
var HauteurRectangle = 48; // 120 48
var Couleur1 = 255; // White
var Couleur2 = 0; // Black
var CouleurFond = 200; // Grey
var Ecrire = false; // true false
var OK = false;
var Stop = false;

Limni = [
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 1, 1, 1, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
];

Limni = [
  0, 0, 0, 0, 0, 0,
  0, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  0, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 0,
  1, 1, 1, 0, 0, 0,
  1, 0, 0, 0, 0, 0,
  1, 1, 1, 0, 0, 0,
  1, 0, 0, 0, 0, 0,
  1, 1, 1, 0, 0, 0,
];

var Limni1 = Limni.slice(); // Astuce!

function setup() {
  createCanvas(windowWidth, windowHeight);
  // frameRate(30);
  noStroke();
  if (Ecrire) stroke(200); // Pour voir...
  background(CouleurFond);
  Couleur1 = color(255); // White
  // Couleur2 = color(0, 10); // Black
  Couleur2 = color(0); // Black
}

function draw() {
  translate(20, 20);
  DessinLimni(Limni1);
  if (frameCount % 6 == 0) { // 60
    for (var f = 0; f < 1; f++) { // f < 15
      if (!Stop) {
        do {
          OK = false;
          // Recherche une cellule = 1
          do Alea = int(random(0, 60)) // Mettre 30 pour limiter 1/2 tableau superieur
          while (Limni1[Alea] == 0);
          Limni1[Alea] = 0;
          if (Ecrire) print("Alea = " + Alea);
          // print("CreationSeul(" + Alea + ") = " + CreationSeul(Alea));
          if (!CreationSeul(Alea)) Limni1[Alea] = 1;
          else OK = true;
        }
        while (!OK);

        do {
          OK = false;
          // Recherche une cellule = 0
          do Alea2 = int(random(0, 60))
          while (Limni1[Alea2] == 1);
          // Recherche une cellule qui touche une cellule = 1
          if ((Limni1[Alea2 - 6] == 1) & (Alea2 > 5)) OK = true;
          if ((Limni1[Alea2 - 1] == 1) & (Alea2 % 6 != 0)) OK = true;
          if ((Limni1[Alea2 + 1] == 1) & (Alea2 % 6 != 5)) OK = true;
          if ((Limni1[Alea2 + 6] == 1) & (Alea2 < 54)) OK = true;
        }
        while (!OK);
        Limni1[Alea2] = 1;
        if (Ecrire) print("OK");
      }
    }

    fill(0);
    textSize(16);
    // text("Click to reset", 0, 11 * HauteurRectangle);
    text("Click: Play / Stop", 0, 11 * HauteurRectangle);
  }
}

function DessinLimni(Limn) {
  if (Ecrire) textSize(12);
  for (var r = 0; r < 10; r++)
    for (var c = 0; c < 6; c++) {
      if (Limn[c + r * 6] == 0) fill(Couleur1);
      else fill(Couleur2);
      rect(LargeurRectangle * c, HauteurRectangle * r, LargeurRectangle, HauteurRectangle);
      fill(255, 0, 0);
      if (Ecrire) text(c + r * 6, LargeurRectangle * (c + 0.4), HauteurRectangle * (r + 0.8));
    }
}

function CreationSeul(c) {
  var OK = true;
  // print("CreationSeul(c)    c = " + c);
  // Recherche une cellule qui touche une cellule = 1
  if ((Limni1[c - 6] == 1) & Seul(c - 6) & (c > 5)) OK = false;
  if ((Limni1[c - 1] == 1) & Seul(c - 1) & (c % 6 != 0)) OK = false;
  if ((Limni1[c + 1] == 1) & Seul(c + 1) & (c % 6 != 5)) OK = false;
  if ((Limni1[c + 6] == 1) & Seul(c + 6) & (c < 54)) OK = false;
  if (Ecrire) print("CreationSeul(" + c + ") = " + OK);
  return OK
}

function Seul(c) {
  var OK = true;
  // print("Seul(c)    c = " + c);
  // Recherche une cellule qui touche une cellule = 1
  if ((Limni1[c - 6] == 1) & (c > 5)) OK = false;
  if ((Limni1[c - 1] == 1) & (c % 6 != 0)) OK = false;
  if ((Limni1[c + 1] == 1) & (c % 6 != 5)) OK = false;
  if ((Limni1[c + 6] == 1) & (c < 54)) OK = false;
  if (Ecrire) print("Seul(" + c + ") = " + OK);
  return OK
}

function mouseClicked() {
  // Limni1 = Limni.slice(); // Astuce!
  Stop = !Stop;
}

function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
  background(CouleurFond);
}